#include "../include/gbGraphics.hpp"

namespace GhulbusGraphics {
	gbGraphicsObject::gbGraphicsObject()
	{
		;
	}
	gbGraphicsObject::~gbGraphicsObject()
	{
		;
	}


	gbGraphicsManager::~gbGraphicsManager() 
	{
		if(m_Overlay) { delete m_Overlay;  m_Overlay = NULL; }
	}
	gbGraphicsManager::gbGraphicsManager()
		:m_scrWidth(-1), m_scrHeight(-1), m_isFullscreen(false), m_isRendering(0), m_done(false),
		 m_clearcolor(GhulbusGraphics::GBCOLOR32::XRGB(0, 0, 0)), m_Overlay(NULL)
	{
	}
	bool gbGraphicsManager::IsRendering() { 
		return m_isRendering; 
	}
	void gbGraphicsManager::SetClearColor(GBCOLOR c) { 
		m_clearcolor = c; 
	}
	int gbGraphicsManager::GetScreenWidth() {
		return m_scrWidth; 
	}
	int gbGraphicsManager::GetScreenHeight() {
		return m_scrHeight; 
	}
	bool gbGraphicsManager::IsFullscreen() {
		return m_isFullscreen;
	}
	bool gbGraphicsManager::IsDone() {
		return m_done;
	}
	void gbGraphicsManager::SetDone() {
		m_done = true;
	}
	gbTexture* gbGraphicsManager::GetOverlaySurface()
	{
		if( m_Overlay->IsLocked() || m_isRendering ) {
			throw( Ghulbus::gbException( Ghulbus::gbException::GB_INVALIDCONTEXT ) );
		}
		return m_Overlay;
	}
}

