#include "../include/gbTexture.hpp"

namespace GhulbusGraphics {
#ifdef _GHULBUSGRAPHICS__USE_D3D9_
	gbTexture_D3D9::gbTexture_D3D9(LPDIRECT3DTEXTURE9 texture)
		:m_lpTex(texture)
	{
		D3DSURFACE_DESC tmp;
		m_lpTex->GetLevelDesc(0, &tmp);
		m_width = tmp.Width;
		m_height = tmp.Height;
	}

	gbTexture_D3D9::~gbTexture_D3D9()
	{
		if(m_isLocked) {
			m_lpTex->UnlockRect(0);
		}
	}

	void gbTexture_D3D9::LockTexture(GBCOLOR** pData, int* pPitch) 
	{
		if(m_isLocked) {
			throw( Ghulbus::gbException( Ghulbus::gbException::GB_INVALIDCONTEXT ) );
		}
		D3DLOCKED_RECT rct;
		if(m_lpTex->LockRect(0, &rct, NULL, 0) != D3D_OK) {
			throw( Ghulbus::gbException( Ghulbus::gbException::GB_FAILED ) );
		}
		*pData  = static_cast<GBCOLOR*>(rct.pBits);
		*pPitch = rct.Pitch / sizeof(GBCOLOR);
		m_isLocked = true;
	}

	void gbTexture_D3D9::UnlockTexture() {
		if(!m_isLocked) {
			throw( Ghulbus::gbException( Ghulbus::gbException::GB_INVALIDCONTEXT ) );
		}
		if(m_lpTex->UnlockRect(0) != D3D_OK) {
			throw( Ghulbus::gbException( Ghulbus::gbException::GB_FAILED ) );
		}
		m_isLocked = false;
	}

	LPDIRECT3DTEXTURE9 gbTexture_D3D9::GetD3D9Texture() {
		if(m_isLocked) {
			throw( Ghulbus::gbException( Ghulbus::gbException::GB_INVALIDCONTEXT ) );
		}
		return m_lpTex;
	}

#endif
}

